import { Consumer, Subscription, Mixin } from '@rails/actioncable';
import { IWebSocketsConfig, ISocketHandlers } from '@boldpenguin/sdk-types';

declare const DEFAULT_HANDLER: () => void;
declare class SDKWebSockets {
    cable?: Consumer;
    timeout: number;
    private _config;
    private _socketConnected;
    constructor(config: IWebSocketsConfig);
    get id(): string;
    start(): Consumer | undefined;
    validate(): void;
    connect(): Consumer | undefined;
    handleConnected: (handler: VoidFunction) => VoidFunction;
    handleDisconnected: (disconnectHandler: VoidFunction, timeoutHandler?: VoidFunction | undefined) => VoidFunction;
    getHandlers(handlers: Partial<ISocketHandlers>): ISocketHandlers;
    subscribe(channel: string, params: {
        [key: string]: string;
    } | undefined, handlers: Partial<ISocketHandlers>): (Subscription<Consumer> & Mixin) | undefined;
    disconnect(destroyCable?: boolean): void;
    cleanup(cable: Consumer | undefined, destroyCable: boolean): void;
    socketTimeOut(): void;
}

export { DEFAULT_HANDLER, SDKWebSockets };
